from odoo import models, fields

class Partner(models.Model):
    _inherit = "res.partner"

    redeem_method = fields.Selection([('auto', 'Monthly Automatic'), ('manual', 'Manual Invoice')], string='Sales Redeeming Method', default='manual')
    notify_on_module_comment = fields.Boolean(string='Receive an e-mail if a comment is posted on a module page', default=True)
    bank_account_number = fields.Char('Bank Account Number')
    bank_account_holder_name = fields.Char('Bank Account Holder Name')
    bank_name = fields.Char('Bank Name')
    bank_code = fields.Char('Bank BIC/SWIFT Code')

class ResUsers(models.Model):
    _inherit = "res.users"

    banned = fields.Boolean(string="Banned", default=False)

    def write(self, values):
        if 'banned' in values:
            banned = bool(values.get('banned'))
            modules = self.env["loempia.module"].search([('repo_maintainer_id', 'in', self.ids), ('status', '!=', 'blocked')])
            modules.status = banned and 'banned' or 'invalid'
            modules.mapped('repo_id').to_scan = not banned

        return super(ResUsers, self).write(values)

    def toggle_ban(self):
        self.ensure_one()
        values = {'banned': not self.banned}
        return self.write(values)
